﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: True
#End Region

Sub Process_Globals
	Private nid As Int = 1
	Private GPS As GPS
	Private Tracking As Boolean
	Private LastUpdateTime As Long
	Private lock As PhoneWakeState
		
'#########################################################

	Private manager As BleManager2
	Private DataFormat As String
	Private RuuviID,RuuviTemp,RuuviFeuchte As String
End Sub

Sub Service_Create
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_NEVER 'we are handling it ourselves
	GPS.Initialize("gps")
	manager.Initialize("manager") 
	lock.PartialLock
End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StartForeground(nid, CreateNotification("..."))
	StartServiceAt(Me, DateTime.Now + 30 * DateTime.TicksPerMinute, True)
	Track
	
End Sub

Public Sub Track
	Scan
	If Tracking Then Return
	If Starter.rp.Check(Starter.rp.PERMISSION_ACCESS_FINE_LOCATION) = False Then
		Log("No permission")
		Return
	End If
	GPS.Start(0, 0)
	Tracking = True
End Sub

Sub GPS_LocationChanged (Location1 As Location)
	If DateTime.Now > LastUpdateTime + 10 * DateTime.TicksPerSecond Then
		Dim n As Notification = CreateNotification($"$2.5{Location1.Latitude} / $2.5{Location1.Longitude}"$)
		n.Notify(nid)
		LastUpdateTime = DateTime.Now
		Log($"$2.5{Location1.Latitude} / $2.5{Location1.Longitude}"$)
	End If
End Sub

Sub CreateNotification (Body As String) As Notification
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_LOW)
	notification.Icon = "icon"
	notification.SetInfo("Tracking location", Body, Main)
	Return notification
End Sub

Sub Service_Destroy
	If Tracking Then
		GPS.Stop
	End If
	Tracking = False
	lock.ReleasePartialLock
End Sub

Public Sub Scan

	RuuviID = "leer"
	RuuviTemp = "0"
	RuuviFeuchte = "0"
  
If manager.State <> manager.STATE_POWERED_ON Then	
	Log("Not powered on")		
Else
 
 Log("Scannen wird gestartet")
 
 Do While True
   manager.Scan2(Null, True)
   Log("Scanne jetzt")
   Sleep(30000) 'Scanne 30 Sekunden lang
   manager.StopScan 'Stoppe den Scan
   Sleep(1000) 'Mache 1 Sekunde Pause und fange wieder an zu scannen.
 Loop
 
End If
	
End Sub

Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)

Dim bc As ByteConverter	
Dim key As Int = -1 'type is important. Must be Int.
If AdvertisingData.ContainsKey(key) Then	
   Dim Data() As Byte = AdvertisingData.Get(key)
    Dim hex As String = bc.HexFromBytes(Data)  

If hex.Length > 30 Then 'Überprüfe ob die Daten lang genug sind 

DataFormat = hex.SubString2(4, 6) 'Welches Data-Format liegt vor?	   
If DataFormat = "05" Then 
  
	Dim RuuviLuftfeuchte As Double = Bit.Or(Bit.ShiftLeft(Bit.And(Data( 5), 0xFF), 8), Bit.And(Data( 6), 0xFF)) / 400
	Dim RuuviTemperature As Double = Bit.Or(Bit.ShiftLeft(Bit.And(Data( 3), 0xFF), 8), Bit.And(Data( 4), 0xFF))	

	If RuuviTemperature > 32767 Then
	RuuviTemperature = RuuviTemperature - 65534
	End If
	RuuviTemperature = RuuviTemperature / 200


'------------------------------------------------------------------


	RuuviID = Id
	RuuviTemp = NumberFormat(RuuviTemperature,1,2)
	RuuviFeuchte = NumberFormat(RuuviLuftfeuchte,1,2)
	
	'Log(RuuviID)
	Log(RuuviTemp&" | "&RuuviFeuchte)

	

End If 
End If
End If
 
End Sub


Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub